import sys
import os
import re
import common
forge = sys.modules["forge"]

def setup(module):
	for tbb_source in forge.tbb_sources:
		if not os.path.exists(tbb_source[2]) or not os.path.exists(tbb_source[3]):
			sys.stdout.write("-" + tbb_source[0] + " ")
			continue

		tbb_lib = common.find_tbb_lib(tbb_source[3])
		if tbb_lib == '':
			sys.stdout.write("-" + tbb_source[0] + " ")
			continue

		if tbb_source[0] == "":
			sys.stdout.write("/ ")
		else:
			sys.stdout.write(tbb_source[0] + " ")

#		sys.stdout.write(tbb_lib + " ")

		srcList = [	"WorkTbb",
					"tbb.pmh",
					"tbbDL" ]

		variant = tbb_source[0]
		if variant != "":
			variantPath = module.modPath + '/' + variant
			if os.path.lexists(variantPath) == 0:
				os.symlink('.', variantPath)

			srcListVariant = []
			for src in srcList:
				srcListVariant += [ variant + '/' + src ]
			srcList = srcListVariant

		dllname = "fexTbb" + variant

		dll = module.DLL( dllname, srcList )

		for src in srcList:
			relativePath = forge.RelativePath(forge.rootPath,module.modPath)
			modObjPath = os.path.join(forge.objPath, relativePath)
			objName = modObjPath + '/' + src
			if re.compile(r'(.*)\.pmh$').match(src):
				objName += '.gch'
			else:
				objName += forge.objsuf
			srcTarget = forge.FindTarget(objName)
			srcTarget.includemap = { 'tbb' : tbb_source[2] }

		dll.linkmap = { "tbb" :
				"-L" + tbb_source[3] + ' -l' + tbb_lib }
		if tbb_source[0] == '':
			dll.linkmap["tbb"] += ' -Xlinker -rpath ' + tbb_source[3]

		deplibs = [ "fePlatformLib" ]

		forge.deps( [ dllname + "Lib" ], deplibs )
